(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('path'), require('mkdirp'), require('@angular/core/testing'), require('@ngrx/core'), require('cheerio'), require('parse5'), require('@angular/core'), require('rxjs/operator/share'), require('rxjs/Observable'), require('lodash'), require('fs'), require('js-yaml'), require('diff'), require('chalk')) :
    typeof define === 'function' && define.amd ? define(['exports', 'path', 'mkdirp', '@angular/core/testing', '@ngrx/core', 'cheerio', 'parse5', '@angular/core', 'rxjs/operator/share', 'rxjs/Observable', 'lodash', 'fs', 'js-yaml', 'diff', 'chalk'], factory) :
    (factory((global.jasmineAngularSnapshotTesting = global.jasmineAngularSnapshotTesting || {}),global.path,global.mkdirp,global.ng.core.testing,global.ngrx.core,global.cheerio,global.parse5,global.ng.core,global.Rx.Observable.prototype,global.Rx,global.lodash,global.fs,global.yaml,global.diff,global.chalk));
}(this, (function (exports,path,mkdirp,_angular_core_testing,_ngrx_core,cheerio,parse5,_angular_core,rxjs_operator_share,rxjs_Observable,lodash,fs,yaml,diff,chalk) { 'use strict';

var Serializer = require('parse5/lib/serializer');
var pretty = require('pretty');
var originalEscapeString = Serializer.escapeString;
Serializer.escapeString = function (str) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    if (!Boolean(str)) {
        return str;
    }
    return originalEscapeString.apply(void 0, [str].concat(args));
};
var treeAdapter = parse5.treeAdapters.htmlparser2;
function removeAngularSpecificMarkup(content) {
    var $ = cheerio.load(content);
    $('*').each(function (_, element) {
        var attribs = Object.keys(element.attribs)
            .filter(function (attr) { return !(attr.startsWith('_ng')); })
            .reduce(function (all, next) {
            return Object.assign(all, (_a = {}, _a[next] = element.attribs[next], _a));
            var _a;
        }, {});
        element.attribs = attribs;
    });
    $.root().find('*').contents().filter(function (_, element) { return element.type === 'comment'; }).remove();
    return $.html();
}
function serializeNode(node) {
    return parse5.serialize(node, { treeAdapter: parse5.treeAdapters.htmlparser2 });
}
function mapToTemplate(el) {
    return isTemplateElement(el) ? treeAdapter.getTemplateContent(el) : el;
}
function mapFixtureToNode(fixture) {
    return fixture.debugElement.nativeElement;
}
function isTemplateElement(el) {
    return isElementNode(el) && el.tagName === 'template';
}
function isElementNode(node) {
    return node ? treeAdapter.isElementNode(node) : false;
}
var serializeComponentFixture = _ngrx_core.compose(pretty, removeAngularSpecificMarkup, serializeNode, mapToTemplate, mapFixtureToNode);
_angular_core_testing.ComponentFixture.prototype['toJSON'] = function () {
    return serializeComponentFixture(this);
};

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (undefined && undefined.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (undefined && undefined.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var observeSpecStarted = function (env) { return new rxjs_Observable.Observable(function (observer) {
    env.addReporter({
        specStarted: function (result) { return observer.next(result); },
        jasmineDone: function () { return observer.complete(); }
    });
}); };
var observeSpecDone = function (env) { return new rxjs_Observable.Observable(function (observer) {
    env.addReporter({
        specDone: function (result) { return observer.next(result); },
        jasmineDone: function () { return observer.complete(); }
    });
}); };
var observeSuiteStarted = function (env) { return new rxjs_Observable.Observable(function (observer) {
    env.addReporter({
        suiteStarted: function (result) { return observer.next(result); },
        jasmineDone: function () { return observer.complete(); }
    });
}); };
var observeSuiteDone = function (env) { return new rxjs_Observable.Observable(function (observer) {
    env.addReporter({
        suiteDone: function (result) { return observer.next(result); },
        jasmineDone: function () { return observer.complete(); }
    });
}); };
var JASMINE_ENV = new _angular_core.OpaqueToken('Jasmine Env');
var SnapshotReporter = (function () {
    function SnapshotReporter(env) {
        this.specStarted$ = rxjs_operator_share.share.call(observeSpecStarted(env));
        this.specDone$ = rxjs_operator_share.share.call(observeSpecDone(env));
        this.suiteStarted$ = rxjs_operator_share.share.call(observeSuiteStarted(env));
        this.suiteDone$ = rxjs_operator_share.share.call(observeSuiteDone(env));
    }
    return SnapshotReporter;
}());
SnapshotReporter = __decorate([
    _angular_core.Injectable(),
    __param(0, _angular_core.Inject(JASMINE_ENV)),
    __metadata("design:paramtypes", [Object])
], SnapshotReporter);
var PROVIDERS = [
    { provide: JASMINE_ENV, useFactory: function () { return jasmine.getEnv(); } },
    SnapshotReporter
];

var __decorate$2 = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var SnapshotConfig = SnapshotConfig_1 = (function () {
    function SnapshotConfig() {
    }
    SnapshotConfig.defaults = function () {
        return {
            fileExtension: 'snap',
            failOnSnapshotDiscovery: false,
            discardOldSnapshots: false
        };
    };
    SnapshotConfig.withDefaults = function (config) {
        return lodash.assign(SnapshotConfig_1.defaults(), config);
    };
    return SnapshotConfig;
}());
SnapshotConfig = SnapshotConfig_1 = __decorate$2([
    _angular_core.Injectable()
], SnapshotConfig);
var SnapshotConfig_1;

var __extends = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate$4 = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata$3 = (undefined && undefined.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var FileSystemAdapter = (function () {
    function FileSystemAdapter() {
    }
    return FileSystemAdapter;
}());
FileSystemAdapter = __decorate$4([
    _angular_core.Injectable()
], FileSystemAdapter);
var NodeFileSystemAdapterBackend = (function () {
    function NodeFileSystemAdapterBackend() {
    }
    Object.defineProperty(NodeFileSystemAdapterBackend.prototype, "filesystem", {
        get: function () {
            return fs;
        },
        enumerable: true,
        configurable: true
    });
    return NodeFileSystemAdapterBackend;
}());
NodeFileSystemAdapterBackend = __decorate$4([
    _angular_core.Injectable()
], NodeFileSystemAdapterBackend);
var NodeFileSystemAdapter = (function (_super) {
    __extends(NodeFileSystemAdapter, _super);
    function NodeFileSystemAdapter(backend) {
        var _this = _super.call(this) || this;
        _this.backend = backend;
        return _this;
    }
    NodeFileSystemAdapter.prototype.fileExists = function (path$$1) {
        return this.backend.filesystem.existsSync(path$$1);
    };
    NodeFileSystemAdapter.prototype.loadFile = function (path$$1) {
        return this.backend.filesystem.readFileSync(path$$1, 'utf8');
    };
    NodeFileSystemAdapter.prototype.saveFile = function (path$$1, content) {
        this.backend.filesystem.writeFileSync(path$$1, content, 'utf8');
    };
    return NodeFileSystemAdapter;
}(FileSystemAdapter));
NodeFileSystemAdapter = __decorate$4([
    _angular_core.Injectable(),
    __metadata$3("design:paramtypes", [NodeFileSystemAdapterBackend])
], NodeFileSystemAdapter);
var PROVIDERS$3 = [
    { provide: FileSystemAdapter, useClass: NodeFileSystemAdapter },
    NodeFileSystemAdapterBackend
];

var __decorate$5 = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var YamlSerializer = (function () {
    function YamlSerializer() {
    }
    YamlSerializer.prototype.parse = function (content) {
        return yaml.safeLoad(content);
    };
    YamlSerializer.prototype.serialize = function (content) {
        return yaml.safeDump(content, { lineWidth: Infinity });
    };
    return YamlSerializer;
}());
YamlSerializer = __decorate$5([
    _angular_core.Injectable()
], YamlSerializer);
var PROVIDERS$4 = [
    YamlSerializer
];

var __decorate$3 = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata$2 = (undefined && undefined.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var SnapshotFileHandler = (function () {
    function SnapshotFileHandler(config, fileSystem, yaml$$1) {
        this.config = config;
        this.fileSystem = fileSystem;
        this.yaml = yaml$$1;
    }
    SnapshotFileHandler.prototype.save = function (path$$1, snapshots) {
        this.fileSystem.saveFile(path$$1, this.yaml.serialize(snapshots));
    };
    SnapshotFileHandler.prototype.load = function (path$$1) {
        if (this.config.discardOldSnapshots || !this.fileSystem.fileExists(path$$1)) {
            return {};
        }
        var content = this.fileSystem.loadFile(path$$1);
        return this.yaml.parse(content);
    };
    return SnapshotFileHandler;
}());
SnapshotFileHandler = __decorate$3([
    _angular_core.Injectable(),
    __metadata$2("design:paramtypes", [SnapshotConfig,
        FileSystemAdapter,
        YamlSerializer])
], SnapshotFileHandler);
var PROVIDERS$2 = [
    SnapshotFileHandler
];

function diffSnapshots(oldSnapshot, newSnapshot) {
    var result = diff.diffLines(oldSnapshot, newSnapshot);
    var message = result.map(function (chunk) {
        var color = chunk.added ? chalk.green : chunk.removed ? chalk.red : chalk.grey;
        return color(chunk.value);
    }).join('\n');
    var pass = result.reduce(function (all, next) {
        return all && !next.added && !next.removed;
    }, true);
    return {
        pass: pass,
        message: "Snapshot did not match baseline: \n \n" + message
    };
}

var __decorate$1 = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata$1 = (undefined && undefined.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var SnapshotRunner = (function () {
    function SnapshotRunner(config, fileHandler, reporter) {
        var _this = this;
        this.config = config;
        this.fileHandler = fileHandler;
        this.reporter = reporter;
        this.specCounter = 0;
        this.encounteredSnapshots = {};
        this.loadedSnapshots = {};
        this.activeFilePath = null;
        reporter.specStarted$.subscribe(function (spec) { return _this.setSpecDescription(spec); });
    }
    SnapshotRunner.prototype.setSpecDescription = function (spec) {
        this.specDescription = spec.fullName;
        this.specCounter = 0;
    };
    SnapshotRunner.prototype.getCurrentSnapshot = function () {
        var notFound = { found: false };
        if (!Boolean(this.loadedSnapshots[this.specDescription])) {
            return notFound;
        }
        var specSnapshots = this.loadedSnapshots[this.specDescription];
        if (!Boolean(specSnapshots[this.specCounter])) {
            return notFound;
        }
        var currentSnapshot = specSnapshots[this.specCounter];
        return { found: true, snapshot: currentSnapshot };
    };
    SnapshotRunner.prototype.encounterSnapshot = function (snapshot) {
        if (this.config.failOnSnapshotDiscovery) {
            throw new Error("Snapshot missing for \"" + this.specDescription + "\"");
        }
        if (!Boolean(this.encounteredSnapshots[this.specDescription])) {
            this.encounteredSnapshots[this.specDescription] = (_a = {},
                _a[this.specCounter] = snapshot,
                _a);
        }
        else {
            this.encounteredSnapshots[this.specDescription][this.specCounter] = snapshot;
        }
        var _a;
    };
    SnapshotRunner.prototype.loadSnapshots = function (file) {
        if (this.activeFilePath !== null) {
            throw new Error("Previous snapshots have not been saved");
        }
        this.loadedSnapshots = this.fileHandler.load(file);
        this.encounteredSnapshots = {};
        this.activeFilePath = file;
    };
    SnapshotRunner.prototype.compareSnapshot = function (fixture) {
        if (this.activeFilePath === null) {
            throw new Error("No snapshots have been loaded");
        }
        if (fixture.toJSON) {
            fixture = fixture.toJSON();
        }
        if (typeof fixture !== 'string') {
            fixture = JSON.stringify(fixture, null, 2);
        }
        var _a = this.getCurrentSnapshot(), found = _a.found, snapshot = _a.snapshot;
        if (!found) {
            this.encounterSnapshot(fixture);
            ++this.specCounter;
            return { pass: true };
        }
        ++this.specCounter;
        return diffSnapshots(snapshot, fixture);
    };
    SnapshotRunner.prototype.saveSnapshots = function () {
        var snapshots = lodash.merge({}, this.loadedSnapshots, this.encounteredSnapshots);
        this.fileHandler.save(this.activeFilePath, snapshots);
        this.activeFilePath = null;
    };
    return SnapshotRunner;
}());
SnapshotRunner = __decorate$1([
    _angular_core.Injectable(),
    __metadata$1("design:paramtypes", [SnapshotConfig,
        SnapshotFileHandler,
        SnapshotReporter])
], SnapshotRunner);
var PROVIDERS$1 = [
    SnapshotRunner
];

var injector;
function initializeSnapshots(config) {
    injector = _angular_core.ReflectiveInjector.resolveAndCreate([
        PROVIDERS,
        PROVIDERS$1,
        PROVIDERS$4,
        PROVIDERS$2,
        PROVIDERS$3,
        { provide: SnapshotConfig, useValue: SnapshotConfig.withDefaults(config) }
    ]);
}
function getRunner() {
    return injector.get(SnapshotRunner);
}
function getConfig() {
    return injector.get(SnapshotConfig);
}

function toMatchSnapshot(actual) {
    return getRunner().compareSnapshot(actual);
}
var installSnapshotMatcher = function () { return jasmine.addMatchers({
    toMatchSnapshot: function () { return ({
        compare: toMatchSnapshot
    }); }
}); };

jasmine.getEnv().beforeAll(installSnapshotMatcher);
function load$1(module) {
    var specDirectoryPath = path.dirname(module.filename);
    var specFileName = path.basename(module.filename);
    var snapshotDirectoryPath = path.resolve(specDirectoryPath, '__snapshots__/');
    var snapshotFilePath = path.resolve(snapshotDirectoryPath, specFileName + "." + getConfig().fileExtension);
    mkdirp.sync(snapshotDirectoryPath);
    getRunner().loadSnapshots(snapshotFilePath);
}
function save() {
    getRunner().saveSnapshots();
}

exports.initializeSnapshots = initializeSnapshots;
exports.load = load$1;
exports.save = save;

Object.defineProperty(exports, '__esModule', { value: true });

})));
