import * as path from 'path';
import * as mkdirp from 'mkdirp';
import './src/component-fixture';
import { installSnapshotMatcher } from './src/matcher';
import { initializeSnapshots, getRunner, getConfig } from './src/env';
jasmine.getEnv().beforeAll(installSnapshotMatcher);
export { initializeSnapshots };
export function load(module) {
    var specDirectoryPath = path.dirname(module.filename);
    var specFileName = path.basename(module.filename);
    var snapshotDirectoryPath = path.resolve(specDirectoryPath, '__snapshots__/');
    var snapshotFilePath = path.resolve(snapshotDirectoryPath, specFileName + "." + getConfig().fileExtension);
    mkdirp.sync(snapshotDirectoryPath);
    getRunner().loadSnapshots(snapshotFilePath);
}
export function save() {
    getRunner().saveSnapshots();
}
//# sourceMappingURL=index.js.map