import { ComponentFixture } from '@angular/core/testing';
import { compose } from '@ngrx/core';
import * as cheerio from 'cheerio';
import * as parse5 from 'parse5';
var Serializer = require('parse5/lib/serializer');
var pretty = require('pretty');
var originalEscapeString = Serializer.escapeString;
Serializer.escapeString = function (str) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    if (!Boolean(str)) {
        return str;
    }
    return originalEscapeString.apply(void 0, [str].concat(args));
};
var treeAdapter = parse5.treeAdapters.htmlparser2;
function removeAngularSpecificMarkup(content) {
    var $ = cheerio.load(content);
    $('*').each(function (_, element) {
        var attribs = Object.keys(element.attribs)
            .filter(function (attr) { return !(attr.startsWith('_ng')); })
            .reduce(function (all, next) {
            return Object.assign(all, (_a = {}, _a[next] = element.attribs[next], _a));
            var _a;
        }, {});
        element.attribs = attribs;
    });
    $.root().find('*').contents().filter(function (_, element) { return element.type === 'comment'; }).remove();
    return $.html();
}
function serializeNode(node) {
    return parse5.serialize(node, { treeAdapter: parse5.treeAdapters.htmlparser2 });
}
function mapToTemplate(el) {
    return isTemplateElement(el) ? treeAdapter.getTemplateContent(el) : el;
}
function mapFixtureToNode(fixture) {
    return fixture.debugElement.nativeElement;
}
function isTemplateElement(el) {
    return isElementNode(el) && el.tagName === 'template';
}
function isElementNode(node) {
    return node ? treeAdapter.isElementNode(node) : false;
}
var serializeComponentFixture = compose(pretty, removeAngularSpecificMarkup, serializeNode, mapToTemplate, mapFixtureToNode);
ComponentFixture.prototype['toJSON'] = function () {
    return serializeComponentFixture(this);
};
//# sourceMappingURL=component-fixture.js.map