/// <reference types="node" />
import * as fs from 'fs';
export declare abstract class FileSystemAdapter {
    abstract fileExists(path: string): boolean;
    abstract loadFile(path: string): string;
    abstract saveFile(path: string, content: string): void;
}
export declare class NodeFileSystemAdapterBackend {
    readonly filesystem: typeof fs;
}
export declare class NodeFileSystemAdapter extends FileSystemAdapter {
    private backend;
    constructor(backend: NodeFileSystemAdapterBackend);
    fileExists(path: string): boolean;
    loadFile(path: string): string;
    saveFile(path: string, content: string): void;
}
export declare const PROVIDERS: (typeof NodeFileSystemAdapterBackend | {
    provide: typeof FileSystemAdapter;
    useClass: typeof NodeFileSystemAdapter;
})[];
