import * as diff from 'diff';
import * as chalk from 'chalk';
export function diffSnapshots(oldSnapshot, newSnapshot) {
    var result = diff.diffLines(oldSnapshot, newSnapshot);
    var message = result.map(function (chunk) {
        var color = chunk.added ? chalk.green : chunk.removed ? chalk.red : chalk.grey;
        return color(chunk.value);
    }).join('\n');
    var pass = result.reduce(function (all, next) {
        return all && !next.added && !next.removed;
    }, true);
    return {
        pass: pass,
        message: "Snapshot did not match baseline: \n \n" + message
    };
}
//# sourceMappingURL=snapshot-differ.js.map