var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable } from '@angular/core';
import { SnapshotConfig } from './snapshot-config';
import { FileSystemAdapter } from './file-system-adapter';
import { YamlSerializer } from './serializer';
var SnapshotFileHandler = (function () {
    function SnapshotFileHandler(config, fileSystem, yaml) {
        this.config = config;
        this.fileSystem = fileSystem;
        this.yaml = yaml;
    }
    SnapshotFileHandler.prototype.save = function (path, snapshots) {
        this.fileSystem.saveFile(path, this.yaml.serialize(snapshots));
    };
    SnapshotFileHandler.prototype.load = function (path) {
        if (this.config.discardOldSnapshots || !this.fileSystem.fileExists(path)) {
            return {};
        }
        var content = this.fileSystem.loadFile(path);
        return this.yaml.parse(content);
    };
    return SnapshotFileHandler;
}());
SnapshotFileHandler = __decorate([
    Injectable(),
    __metadata("design:paramtypes", [SnapshotConfig,
        FileSystemAdapter,
        YamlSerializer])
], SnapshotFileHandler);
export { SnapshotFileHandler };
export var PROVIDERS = [
    SnapshotFileHandler
];
//# sourceMappingURL=snapshot-files.js.map